//
//

void itobp( char *str, unsigned int x )
{
  unsigned int i,j,k;
  k=35;
  for( j = 0 ; j < 4 ; j++ ) {
    str[k--] = ':';
    for( i = 0 ; i < 8 ; i++ ) {
      if( ((1 << (j*8+i)) & x) != 0 ) str[k] = '1'; else str[k] = '0';
      k--;
    }
  }
  if( k!= -1 ) printf("PRoblem\n");
  str[35]=0;
}



void o32_dump( char *fname )
{
  gROOT->Reset();

  FILE *f;
  int  nline = 0;
  char buf[256];
  char str[256];
  int n = 0;
  unsigned int x;
  int nadcline; 
  int iADC;
  int iTB;
  int iMCM, iEv, iRest, iROB, a0, a1, a2;
  int iDCS, iSM, iL, iS, iAB;

  printf("Reading input file: %s\n", fname);
  f = fopen( fname , "r");
  if( f == NULL ) {
    printf("Failed to open file: %s\n", fname );
    exit(0);
  }

  while( fgets( buf, 255, f ) != NULL ) {
    sscanf( buf, "0x%x", &x);
    printf( "0x%08x ", x);
    itobp( str, x );
    printf( "%s", str );
    nline++;

    if( x == 0xaaaaaaaa ) { printf("End-of-Tracklet\n"); continue; }
    if( x == 0x00000000 ) { printf("End-of-Event\n");    continue; }
    if( (x & 0x00000003) == 0x1){
      iDCS  = (x & 0xfff00000) >> 20;
      iSM   = (x & 0x000f8000) >> 15;
      iL    = (x & 0x00007000) >> 12;
      iS    = (x & 0x00000e00) >> 9;
      iAB   = (x & 0x00000100) >> 8;
      iRest = (x & 0x000000ff);
      printf("-> ROC Header (DCS%d SM%02d L%01d S%01d", iDCS, iSM, iL, iS);
      if (iAB == 0) printf(" A side)\n"); else  printf(" B side)\n");      continue;
    }
    if( (x & 0x0000000f) == 0xC){
      iMCM  = (x & 0xff000000) >> 24;
      iEv   = (x & 0x00fffff0) >> 4;
      iRest = (x & 0x0000000f);
      iROB  = iMCM / 16;
      iMCM  = iMCM % 16;                    
      printf("-> MCM-ID (iROB=%d iMCM=%02d iEv=%02d)\n", iROB, iMCM, iEv );
      nadcline = 0;
      continue;
    }
    iADC = nadcline/10;
    iTB  = 3*nadcline%30;
    a0   = (x & 0x00000ffc) >> 2;
    a1   = (x & 0x003ff000) >> 12;
    a2   = (x & 0xffc00000) >> 22;

    printf("-> iADC=%02d, iTB=%02d-%02d, Data: %04d %04d %04d", iADC, iTB, iTB+2, a0, a1, a2 );
    if ( (a0 > 120 || a1 > 120 || a2 > 120) )
      printf(" <- BitFlip? (iROB=%d iMCM=%02d iEv=%02d)!", iROB, iMCM, iEv );
    if ( ( nadcline > 210 ) )
      printf(" <- SIZE? (iROB=%d iMCM=%02d iEv=%02d)!", iROB, iMCM, iEv );
    if( iTB == 27 ) printf("\n");
    printf("\n");
    nadcline++;
  }

  fclose(f);
  printf("Number of lines read: %d\n", nline);

}

// EOF
