#! /usr/bin/perl
#
# Usage: ./o32_plot.pl filename comment
#    OR  ./o32_plot.pl filename
#    OR  ./o32_plot.pl
#
# If filename is not given, it takes _last_data file.
#
# Auto plot tool.

#require "modules/read_setup.pl";

if( $#ARGV == -1 ) {
    $File    = "_last_data";
    $Hist    = "_current/_history";
    $Comment = "-";
    $Nevts = 1;
} elsif( $#ARGV == 0 ) {
    $File    = $ARGV[0];
    $Comment = "-";
    $Nevts = 1;
} elsif( $#ARGV == 1 ) {
    $File    = $ARGV[0];
    $Comment = $ARGV[1];
    $Nevts = 1;
} elsif( $#ARGV == 2 ) {
    $File    = $ARGV[0];
    $Comment = $ARGV[1];
    $Nevts = $ARGV[2];
}

# $ROC_NAME = "L".$ROC_LAYER."C".$ROC_TYPE."-".$ROC_SERIAL;

# Read information from _history


# char *fname, int nevents = 20, char *roc_name = "LxCx-xxx", char *comment = "No comment"

printf("Process file: %s\n", $File);
printf("Comment     : %s\n", $Comment);

$ROC_NAME = "-";
$ROC_TYPE = 1;

printf("ROC name    : %s\n", $ROC_NAME);
printf("ROC Type    : %s\n", $ROC_TYPE);

system("root \'o32_plot.C\(\"$File\", $Nevts, \"$ROC_NAME\", \"$Comment\" , $ROC_TYPE \)\'");

# EOF
