#! /bin/sh
# 
# Flash dcs board with latest firmware
# Chamber data is read from "_setup".
# By C. Lippmann and K. Oyama
#

if [ $# -ne 1 ]; then
    echo ""
    echo "usage  : ./flash_it [dcs_no]"
    echo "example: ./flash_it dcs0654"
    echo ""
    exit;
fi

DCS=$1

echo ""
echo "Do you want to flash the dcs board with new firmware?"
echo "Type 1 for yes or 0 for no!"
read OK
if [ $OK -eq 1 ]; then
    cd ~/dietel/dcs_firmware/
    make FLV=smint install_$DCS
    #pwd
fi

echo "::Finished:: `date`"
echo ""
