#! /bin/sh
#
# By C.Lippmann
#
. _setup.sh

usage() {
    echo ""
    echo "Usage : ./reset_all.sh    -> to reset 5 times all boards in SM"
    echo ""
    echo "No parameter needed!"
    echo ""
    exit;
}

if [ $# -ne 0 ]; then
    usage;
fi

echo "Resetting 5 times all ROBs in Supermodule ..."

for P in $POS_LIST ; do

    DCS=`./modules/getdcsbypos.pl $P`
    ssh $DCS \
	" /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset " &
done

wait

echo "Finished"
