#!/bin/sh
#
# power on DCS boards one after the other
# by DE - 10.09.2006
#

clear

# timeout time
TIMEOUT=2;
# dcs-power.sh location
DCSPOWER=/home/trd/dcsnfs/SM_Test/dcs-power.sh

# turn all off
#[ -x $DCSPOWER ] && $DCSPOWER off
[ -x $DCSPOWER ] && $DCSPOWER off  > /dev/null || exit
echo "all DCS off"

for layer in `seq 0 5`
do
  for stack in `seq 0 4`
  do
    [ -x $DCSPOWER ] && $DCSPOWER ${layer} ${stack} on > /dev/null
    echo -n "dcsl${layer}s${stack} on"
    echo " - sleeping ${TIMEOUT}s"
    sleep $TIMEOUT;
  done
done

echo "all DCS on"

# EOF
